/*   BEM = Batch Equilibrium Model (calculates chemical equilibira)
     Copyright (C) 1996  J. Prenzel (jprenze@gwdg.de)
     
     This program is free software; you can redistribute it and/or
     modify it under the terms of the GNU General Public License
     as published by the Free Software Foundation; either version 2
     of the License, or (at your option) any later version.
     
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
     
     You should have received a copy of the GNU General Public License
     along with this program; if not, write to the Free Software
     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.         */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <errno.h>

#include "bem.h"


void showmod();
void tnum1();
/*....................................... dftest ...................*/                                
int dftest(char *mfile){
  int rc;

  CALL(rc,makecl("test"));
  Mod.nam=mfile;
  CALL(rc,openfiles('m'));
  CALL(rc,openfiles('l'));
  CALL(rc,modinit());
  CALL(rc,init0());
  CALL(rc,slt0());
  tnum1();
  return 0;
}


/*............................................... tnum1 ................*/
void tnum1(){
  double *x, f[MAXDIM], df[MAXDIM][MAXDIM];
  double xl[MAXDIM], fl[MAXDIM], dfn[MAXDIM][MAXDIM];
  double xh[MAXDIM], fh[MAXDIM], a,b,d,r=0.0001;
  int i,ii,nx;

/*   nx=Cl->nelt + Cl->nslt +1; */
  nx=Cl->nelt + Cl->niex + Cl->nslt;
  x=Cl->nus0.xarg;
  setx0();

  fxdfdx(x,nx,f,df); 
  for(i=0;i<nx;i++){
    xl[i]=x[i];
    xh[i]=x[i];
  }

  for(i=0;i<nx;i++){
    for(ii=0;ii<nx;ii++){
      d=fabs(x[ii])*r;
d=1.e-5; 
      xl[ii]-=d;
      xh[ii]+=d;


      fxdfdx(xl,nx,fl,dfn);
      fxdfdx(xh,nx,fh,dfn);
      a=(fh[i]-fl[i])/(xh[ii]-xl[ii]);
      printf("%3d%3d %10g %10g",i,ii,df[i][ii],a);
      if(df[i][ii] != 0. ){
	b=(a-df[i][ii])/df[i][ii];
	printf(" %10g",b);
	if(fabs(b) > 1.e-5){
	  printf("   !!!!!");
	}
      }
      printf("\n");
      xl[ii]+=d;
      xh[ii]-=d;
   }
  }


  return;
}
